﻿Imports System.IO
Imports MSTSCLib
Imports System.Threading
Imports System.Net
Imports System.Net.NetworkInformation
Imports AxMSTSCLib


Public Class Form1

    Public Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer

    Private _DataPath As String = Application.StartupPath
    Private _DataFile As New FileInfo(_DataPath & "\RemoteDesktop\RemoteDesktop.xml")

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        LoadDataSet(DataSet1)

    End Sub

    Public Sub LoadDataSet(ByVal myDS As DataSet)
        myDS.Clear()
        If _DataFile.Exists Then
            myDS.ReadXml(_DataFile.FullName)
        End If
    End Sub

    Public Sub SaveDataSet(ByVal myDS As DataSet)
        myDS.WriteXml(_DataFile.FullName)
        myDS.AcceptChanges()
    End Sub

    Private Sub btnDatenSpeichern_Click(sender As Object, e As EventArgs) Handles btnDatenSpeichern.Click
        If Not IO.Directory.Exists(My.Application.Info.DirectoryPath & "\RemoteDesktop") Then
            ' Nein! Jetzt erstellen...
            Try
                IO.Directory.CreateDirectory(My.Application.Info.DirectoryPath & "\RemoteDesktop")
                ' Ordner wurde korrekt erstellt!
            Catch ex As Exception
                ' Ordner wurde nich erstellt
            End Try
        End If
        Validate()
        DataTable1BindingSource.EndEdit()
        SaveDataSet(DataSet1)
        Refresh()
    End Sub

    Private Sub btnNeueAdresseAnlegen_Click(sender As Object, e As EventArgs) Handles btnNeueAdresseAnlegen.Click
        'TabControl2.SelectedTab = TabControl2.TabPages(TabIndex)
        DataTable1BindingSource.AddNew()
        If String.IsNullOrEmpty(IPTextBox.Text) Then
            'VornameTextBox.Focus()
            IPTextBox.Focus()
            IPTextBox.BackColor = Color.AliceBlue

            'PictureBox1.Refresh()
            Return
        End If
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        If MessageBox.Show("Datensatz wirklich löschen?", "Löschen", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes Then
            DataTable1BindingSource.RemoveCurrent()

        Else
            MessageBox.Show("Keine Daten zum löschen vorhanden", "Fehler...")
        End If
    End Sub

    Private Sub btnConnect_Click(sender As Object, e As EventArgs) Handles btnConnect.Click
        Me.Text = "Verbunden mit RemoteDesktop:  " + IPTextBox.Text + "  Verbunden als:  " + BenutzerTextBox.Text

        'Try

        Dim rdpview As New AxMsRdpClient9NotSafeForScripting
        Dim newTabPage As New TabPage
        newTabPage.Text = ClientNameTextBox.Text
        TabControl1.TabPages.Add(newTabPage)
        newTabPage.Controls.Add(rdpview)
        TabControl1.SelectedIndex = TabControl1.TabCount - 1    'Added by BornToBeRoot --> Bevor das ActiveX Control genutzt werden kann, muss es gezeichnet werden (https://stackoverflow.com/questions/27689826/rdp-client-axhost-invalidactivexstateexception) 
        rdpview.Dock = DockStyle.Fill
        rdpview.UserName = BenutzerTextBox.Text
        rdpview.Domain = DomäneTextBox.Text
        rdpview.Server = IPTextBox.Text
        rdpview.AdvancedSettings9.EnableCredSspSupport = True   'Added by BornToBeRoot --> Windows 10+

        rdpview.AdvancedSettings9.ClearTextPassword = PasswortTextBox.Text  'Added by BornToBeRoot --> besser :)

        rdpview.Connect()
        'Catch ex As Exception
        'MsgBox(ex.ToString & ".", MsgBoxStyle.Exclamation, "An error has occurred")
        'End Try

    End Sub

    Private Sub btnDisconnect_Click(sender As Object, e As EventArgs) Handles btnDisconnect.Click
        'hier soll noch ein code hinzugefügt werden um eine RDP Sitzung vom jeweiligen TabControll zu trennen.
    End Sub
End Class
